-- button.e: button widget
-- j.babor@gns.cri.nz
-- v 0.1    98-03-16

include text.e
include panel.e

global function button(sequence p1,sequence p2,sequence lab,integer f)
-- create new button, defined by diagonal points p1,p2
-- face & edge colors & font setting will be current defaults
-- lab is button label
-- flag:    f=0     ... popped
--          f=1     ... pushed
-- return button sequence
    sequence pl,te1,te2
    pl=panel(p1,p2,colors[1],f)
    te1=text(floor((p1+p2+1)/2),lab,FCC)
    te2=text(floor((p1+p2+1)/2)+1,lab,FCC)
    return {{pl,te1,te2},f,p1,p2} end function

global procedure show_button(sequence w)
    show_panel(w[WS][1])
    show_text(w[WS][w[MF]+2]) end procedure

global procedure click_button(sequence w)
    -- only popped buttons can be clicked
    -- clicked button remains pushed only while rat button is pressed
    sequence s
    if w[MF]=0 then                         -- popped
        s=w                                 -- save original state
        s[WS][1][MF]=w[WS][1][MF]+1         -- switch to pushed look
        s[MF]=w[MF]+1
        show_button(s)
        wait_while(LEFT_BUTTON_PRESSED)
        show_button(w) end if end procedure -- switch back to original look

global function toggle_button(sequence w)
    -- toggle buttons are similar to check boxes
    -- any button can be toggled, irrespective of its original state
    -- return changed button
    integer f,g
    f=w[MF]
    g=w[WS][1][MF]
    if f then
        f=f-1
        g=g-1
    else
        f=f+1
        g=g+1 end if
    w[MF]=f
    w[WS][1][MF]=g
    show_button(w)
    wait_while(LEFT_BUTTON_PRESSED)
    return w end function

global function frame_button(sequence w)
    sequence p
    integer f
    f=w[WS][1][MF]
    if f=0 or f=1 then
        f=f+2
        w[WS][1][MF]=f
        p=w[WS][1]      -- panel
        hide_rat()
        frame(p[LT],p[RB],p[EC][f+1])
        show_rat() end if
    return w end function

global function deframe_button(sequence w)
    sequence p      -- panel
    integer f
    f=w[WS][1][MF]
    if f=2 or f=3 then
        f=f-2
        w[WS][1][MF]=f
        p=w[WS][1]
        hide_rat()
        frame(p[LT],p[RB],p[EC][f+1])
        show_rat() end if
    return w end function
