-- checkbox.e: check box widget
-- j.babor@gns.cri.nz
-- v 0.1    98-03-16

include text.e
include panel.e
include pic.e
include faces.e

global function checkbox(sequence p,sequence lab,integer f)
    -- create new check box, p is top left corner
    -- face & edge colors & font setting will be current defaults
    -- flag: f=0        ... unchecked
    --       f=1        ... checked
    -- return checkbox sequence
    sequence pid,tid,gid
    gid=pic(p+{3,4},TICK,1)
    tid=text({p[1]+20,p[2]+7},lab,FLC)
    pid=panel(p,p+13,colors[7],1)
    return {{pid,gid,tid},f,p,p+{20,13}} end function

global procedure show_checkbox(sequence w)
    show_panel(w[WS][1])
    show_text(w[WS][3])
    if w[MF] then show_pic(w[WS][2]) end if end procedure

global function toggle_checkbox(sequence w)
    -- toggle current state of checkbox
    -- return changed checkbox
    w[MF]=not w[MF]
    if w[MF] then show_pic(w[WS][2])
    else show_panel(w[WS][1]) end if
    wait_while(LEFT_BUTTON_PRESSED)
    return w end function

global function frame_checkbox(sequence w)
    sequence p
    integer f
    f=w[WS][1][MF]      -- panel edge flag
    if f<2 then
        f=f+2
        w[WS][1][MF]=f
        p=w[WS][1]      -- panel
        hide_rat()
        frame(p[LT],p[RB],p[EC][f+1])
        show_rat() end if
    return w end function

global function deframe_checkbox(sequence w)
    sequence p      -- panel
    integer f
    f=w[WS][1][MF]
    if f>=2 then
        f=f-2
        w[WS][1][MF]=f
        p=w[WS][1]
        hide_rat()
        frame(p[LT],p[RB],p[EC][f+1])
        show_rat() end if
    return w end function
