-- hslide.e: horizontal slide - widget
-- j.babor@gns.cri.nz
-- v 0.1    98-03-17

include pane.e
include panel.e
include pic.e
include faces.e

constant
    bh=13,  -- button height
    bw=15   -- button width

global function hslider(sequence p1,sequence p2)
    sequence p,pl,pc
    integer lx,ly
    pl=panel(p1,p2,colors[1],0) -- 'popped' panel
    lx=length(LRARROW[1])
    ly=length(LRARROW)
    p=floor((p1+p2-{lx-1,ly-1})/2)
    pc=pic(p,LRARROW,1)
    return {{pl,pc},0,p1,p2}
end function

global procedure show_hslider(sequence w)
    show_panel(w[WS][1])
    show_pic(w[WS][2])
end procedure


--------------------------------------------------------------------------------

global function hslide(sequence p,integer len,atom pos)
-- horizontal slide
    sequence pn,hs,ps
    integer dx
    pn=pane(p,p+{len,bh}-1,colors[8])
    dx=floor(pos*(len-bw))
    ps={p[1]+dx,p[2]}
    hs=hslider(ps,ps+{bw,bh}-1)
    return {{pn,hs},pos,p,p+{len,bh}-1}
end function

global procedure show_hslide(sequence w)
    show_pane(w[WS][1])
    show_hslider(w[WS][2])
end procedure -- show_hslide

global function click_hslide(sequence w, sequence hook)
    atom pos
    integer drx,rx,x,xmax,h
    sequence p,p1,p2,pn,hs
    h=routine_id(hook)
    pn=w[WS][1]
    hs=w[WS][2]
    p=hs[LT]
    p1=pn[LT]
    p2=pn[RB]
    rx=rat_state[2]
    -- first move slider to rat pointer level
    p[1]=rx-floor((bw+1)/2)+1
    if p[1]<p1[1] then p[1]=p1[1]
    elsif p[1]>p2[1]-bw+1 then p[1]=p2[1]-bw+1 end if
    -- erase old location
    if p[1]>hs[LT][1] then
        hide_rat()
        box(p1,{p[1],p[2]+bh-1},colors[8])
        show_rat()
    elsif p[1]<hs[LT][1] then
        hide_rat()
        box({p[1]+bw-1,p[2]},p2,colors[8])
        show_rat()
    end if
    -- declare new slider (new position) and show it
    hs=hslider(p,p+{bw,bh}-1)
    show_hslider(hs)
    pos=(p[1]-p1[1])/(p2[1]-p1[1]-bw+1)
    if h>=0 then call_proc(h,{pos}) end if
    xmax=p2[1]-p1[1]-bw+1
    x=p[1]-p1[1]
    while left_button_pressed() do
        show_rat()
        drx=rat_state[2]-rx     -- change of rat's x-coordinate
        if drx then
            if drx>0 and x<xmax then
                x=x+drx
                if x>xmax then x=xmax end if
                p[1]=p1[1]+x
                hs=hslider(p,p+{bw,bh}-1)
                show_hslider(hs)
                hide_rat()
                box(p1,{p[1],p[2]+bh-1},colors[8])
                show_rat()
                pos=(p[1]-p1[1])/(p2[1]-p1[1]-bw+1)
                if h>=0 then call_proc(h,{pos}) end if
            elsif drx<0 and x>0 then
                x=x+drx
                if x<0 then x=0 end if
                p[1]=p1[1]+x
                hs=hslider(p,p+{bw,bh}-1)
                show_hslider(hs)
                hide_rat()
                box({p[1]+bw-1,p[2]},p2,colors[8])
                show_rat()
                pos=(p[1]-p1[1])/(p2[1]-p1[1]-bw+1)
                if h>=0 then call_proc(h,{pos}) end if
            end if
            rx=rat_state[2]
        end if
    end while
    w[WS][2]=hs
    w[MF]=pos
    return w
end function -- on_click_hslide
