--  puzzle.e: 15 tile slider
--  j.babor@gns.cri.nz
--  98-03-18

include button.e

constant
    labels={"1","2","3","4","5","6","7","8","9","10","11",
        "12","13","14","15",""}
sequence
    location,   -- index=current slider location, value=slider label
    buttons,sb
integer xo,yo,blank,moves

global procedure init_puzzle(sequence xy)
    integer x,y
    xo=xy[1]  yo=xy[2]  -- global coordinates
    location={}
    for i=1 to 16 do location=append(location,i) end for
    buttons={}
    for i=0 to 15 do
        x=xo+10+remainder(i,4)*30
        y=yo+40+floor(i/4)*30
        buttons=append(buttons, button({x,y},{x,y}+29,-3&#101&labels[i+1],0))
    end for
    sb=button(xy+{9,9},xy+{69,32},-3&#101&"shuffle",0)
end procedure

function change_button(sequence butt, sequence new_label)
    return button(butt[LT],butt[RB],new_label,butt[MF])
end function

procedure show_blank(integer i)
    integer x,y
    i=i-1
    x=xo+10+remainder(i,4)*30
    y=yo+40+floor(i/4)*30
    hide_rat()
    box({x,y},{x,y}+29,7)
    show_rat()
end procedure

procedure show_moves()
    sequence s
    hide_rat()
    box({xo+82,yo+11},{xo+128,yo+30},0) -- erase previous entry
    s=sprintf("%d",moves)
    fselect(FHANDLE)  fj=FRC fx=xo+125  fy=yo+22
    fprint(-1&#10C&s)
    show_rat()
end procedure

procedure shuffle()
    -- random shuffle of all locations
    integer m,n
    for i=1 to 16 do
        m=rand(16)
        n=location[i]
        location[i]=location[m]
        location[m]=n end for
    for i=1 to 16 do
        if location[i]=16 then
            blank=i
            show_blank(i)
        else
            buttons[i]= change_button(buttons[i],-3&#100&labels[location[i]])
            show_button(buttons[i]) end if end for
    moves=0
    show_moves()
end procedure

global procedure show_puzzle()
    tile({xo,yo},{xo+139,yo+172},colors[1],edges[1])
    tile({xo+80,yo+9},{xo+130,yo+32},0,edges[2])
    frame({xo+9,yo+39},{xo+130,yo+160},edges[2])
    show_button(sb)
    shuffle()
end procedure

global procedure track_puzzle()
    integer w
    if left_button_pressed() then
        w=track_widgets(buttons&{sb})
        if w and w<=16 and w!=blank then
            if w+4=blank or w-4=blank or (w+1=blank and remainder(blank,4)!=1)
                or (w-1=blank and remainder(blank,4)) then
                show_blank(w)
                buttons[blank]= change_button(buttons[blank],-3&#100&labels[location[w]])
                show_button(buttons[blank])
                location[blank]=location[w]
                location[w]=16
                blank=w
                moves=moves+1
                show_moves()
            else click_button(buttons[w]) end if
        elsif w=17 then     -- shuffle
            click_button(sb)
            shuffle()
        end if end if
end procedure
