-- rat.ex: superVGA rat tests
-- j.babor@gns.cri.nz
-- rat v 1.00
-- widgets v 0.10
-- 98-03-19

include widgets.e
include button.e
include checkbox.e
include rbuttons.e
include pbutton.e
include hcslides.e
include puzzle.e

constant
    sb13=fload("sysb13.f"),
    mo28=fload("modern28.f"),
    modes={18,19,257,259,261},
    rats={ARROW,ARROW1,TRIANGLE,CROSSHAIR,IBEAM,HAND1,
        HAND2,HGLASS,PENCIL,TB,LR,LTRB,RTLB},
    -- title texture tile in mode 18
    ts={{15},{15},{15},{15},{11},{11},{11},{11},{8},{8},{8},{8},{8},
        {7},{7},{7},{7},{7},{3},{3},{3},{3},{3},{0},{0},{0},{0},{0}}
object junk
sequence pics,rp,rb,b,cb,ft
integer wi,x,db,new_mode,old_mode

ft={}   -- larger font texture
for i=16 to 31 do ft=append(ft,{i}) ft=append(ft,{i}) end for

procedure dragbox_alert()
    fselect(mo28)
    fx=400  fy=275  fj=FCN  fc=10  fs=0  fa=FSH
    fprint("Dragbox Alert")
    fselect(sb13)
    fx=400  fy=320  fj=FCN
    fprint(-3&#10F&"Have you tried my "&#10E&"dragbox"&#10F&" facility ?\n\n"&
    "If not, it's really simple:\n"&
    "just drag the pointer while the "&#10E&"right"&#10F&" rat button is held !\n\n"&
    "But make sure the dragbox checkbox above is "&#10E&"checked"&#10F&".")
end procedure

procedure redraw(integer mode)
    integer sc                      -- screen background color
    hide_rat()                      -- for safety
    erase_drag_box()                -- does no harm
    init_widgets(mode)              -- initialize widget graphics
    set_rgb(rgb)                    -- recover last rgb setting
    fselect(mo28)
    fp={2,2,2,1,-2,2,3,0,0,0}       -- special params for bigger font
    if mode=18 then fc=ts fs=4 sc=12
    elsif mode=19 then fc=ft fs=0 sc=2
    else fc=ft fs=1 sc=9 end if
    box({0, 0},{maxx,maxy},sc)      -- screen background
    fx=20   fy=12   fj=FLN
    fprint(-3&"SuperVGA Rat Demo")
    if mode!=19 then
        fselect(sb13)
        fx=620  fy=22   fj=FRN
        fprint(-3&#10F&"March 1998")
        show_color_sliders()
        show_puzzle() end if
    show_rbuttons(rb)
    show_checkbox(cb)
    show_button(b)
    for i=1 to length(rp) do show_pbutton(rp[i]) end for
    dragbox_alert()
end procedure

-- main ------------------------------------------------------------------------
rb=rbuttons({{{20, 52},"18     (640x480x16)"},
             {{20, 74},"19     (320x200x256)"},
             {{20, 96},"257  (640x480x256)"},
             {{170,52},"259  (800x600x256)"},
             {{170,74},"261  (1024x768x256)"}},3)
cb=checkbox({170, 96},-1&#10E&"right mb dragbox",1)
b=button({266,160},{296,190},-3&#104&" exit",0)
pics={}
for i=1 to length(rats) do
    pics=append(pics,rats[i][2..length(rats[i])]) end for
rp={}
x=20
for i=1 to 7 do         -- top row of rat pointers
    rp=append(rp, pbutton({x,120},{x+30,150},pics[i],XOR,pics[i],XOR,0))
    x=x+41 end for
x=20
for i=8 to 13 do        -- bottom row of rat pointers
    rp=append(rp, pbutton({x,160},{x+30,190},pics[i],XOR,pics[i],XOR,0))
    x=x+41 end for

init_puzzle({20,260})
db=1                    -- drag box function enabled

redraw(modes[rb[MF]])   -- start in mode 257
while get_key()=-1 do   -- main loop
    show_rat()          -- keep rat alive
    if left_button_pressed() then
        old_mode=rb[MF]
        rb=track_rbuttons(rb)
        new_mode=rb[MF]
        if new_mode!=old_mode then redraw(modes[new_mode]) end if
        wi=track_widgets(rp&{b,cb})
        if wi>0 and wi<14 then          -- rat pointer change button
            rat_pointer(rats[wi])
            click_pbutton(rp[wi])
        elsif wi=14 then                -- exit button pressed
            click_button(b)
            exit
        elsif wi=15 then
            cb=toggle_checkbox(cb)
            db=cb[MF]
            if not db then erase_drag_box() end if end if
        track_color_sliders()
        track_puzzle()
    end if

    if db and right_button_pressed() then
        junk=drag_box(1,RIGHT_BUTTON_PRESSED) end if
end while
junk=graphics_mode(-1)
