-- rbutton.e: radio button for widgets
-- j.babor@gns.cri.nz
-- v 0.1    98-03-11

include text.e
include panel.e
include pic.e
include faces.e

function rbutton(sequence p,sequence lab,integer f)
--  create new radio button, p is top left corner
    -- face & edge colors & font setting will be current defaults
    -- flag: f=0        ... unselected
    --       f=1        ... selected
    -- return rbutton sequence
    sequence pid,tid,gid
    gid=pic(p+{4,4},BULLET,1)
    tid=text({p[1]+20,p[2]+7},lab,FLC)
    pid=panel(p,p+13,colors[7],1)
    return {{pid,gid,tid},f,p,p+{20,13}} end function

procedure show_rbutton(sequence w)
    show_panel(w[WS][1])
    show_text(w[WS][3])
    if w[MF] then show_pic(w[WS][2]) end if end procedure

global function rbuttons(sequence rb,integer n)
-- create radio button cluster
-- rb is sequence of sequences: {{xy1,label1},{xy2,label2}...}
-- where xy is left top button corner
-- n is index of radio button to be initially selected
-- rbuttons are drawn unframed (default)
-- return cluster widget
    sequence ws    -- sequence of rbuttons
    ws={}
    for i=1 to length(rb) do
        ws=append(ws,rbutton(rb[i][1],rb[i][2],n=i)) end for
    return {ws,n} end function

global procedure show_rbuttons(sequence w)
    for i=1 to length(w[WS]) do show_rbutton(w[WS][i]) end for end procedure

global function track_rbuttons(sequence s)
-- track *single* rbutton cluster s
-- return cluster (rbuttons) sequence (changed or not!)
    integer new,old
    old=s[MF]
    new=track_widgets(s[WS])
    if new and new!=old then
        s[WS][old][MF]=0
        show_panel(s[WS][old][WS][1])
        s[MF]=new
        s[WS][new][MF]=1
        show_pic(s[WS][new][WS][2])
        wait_while(LEFT_BUTTON_PRESSED) end if
    return s end function
